<?php
/*
Plugin Name: Blog Card Jin
Plugin URI: http://www.tabibitojin.com
Description: 記事内のサイト内リンクをブログカード形式で表示する
Author: Jin
Version: 1.1.0
Author URI: http://www.tabibitojin.com
*/
/* -----------------------------------
ブログカード　参考サイト
http://nelog.jp/wordpress-blog-card
----------------------------------- */

//サイトドメインを取得
function blog_card_jin_20160901_get_this_site_domain(){
	//ドメイン情報を$results[1]に取得する
	preg_match( '/https?:\/\/(.+?)\//i', admin_url(), $results );
	return $results[1];
}

//本文抜粋を取得する関数（綺麗な抜粋文を作成するため）
function blog_card_jin_20160901_get_the_custom_excerpt($content, $length) {
	$content 	=	preg_replace('/<!--more-->.+/is',"",$content); //moreタグ以降削除
	$content 	=	strip_shortcodes($content);//ショートコード削除
	$content 	=	strip_tags($content);//タグの除去
	$content 	=	str_replace("&nbsp;","",$content);//特殊文字の削除（今回はスペースのみ）
	$content 	=	mb_substr($content,0,$length);//文字列を指定した長さで切り取る
	return $content;
}

//本文中のURLをブログカードタグに変更する
function blog_card_jin_20160901_url_to_blog_card($the_content) {
	if ( is_singular() ) {//投稿ページもしくは固定ページのとき
	//1行にURLのみが期待されている行（URL）を全て$mに取得
	$res = preg_match_all('/^(<p>)?(<a.+?>)?https?:\/\/'.preg_quote(blog_card_jin_20160901_get_this_site_domain()).'\/[-_.!~*\'()a-zA-Z0-9;\/?:\@&=+\$,%#]+(<\/a>)?(<\/p>)?(<br ? \/>)?$/im', $the_content,$m);

	/* カード全体の横の長さ */	
	$card_width			= get_option('bcj_set_card_width');
	/* ヘッダー文字列 */
	$header_title 		= get_option('bcj_set_header_title'); // ヘッダー文字列
	if($header_title ==""){
		$header_title		= '';
	}
	else{
		$header_title		= '<div class="header">'.$header_title.'</div>';
	}

	/* 抜粋文字数 */	
	$excerpt_length		= get_option('bcj_set_length_value');//抜粋の文字数取得
	/* NoImage の表示非表示 */
	$noimage_setting 	= get_option('bcj_set_noimagedisp_value'); // 設定値の取得　初期値は"表示する"
	/* サムネイルの表示非表示 */
	$thumbnail_setting 	= get_option('bcj_set_thubnaildisp_value'); // 設定値の取得　初期値は"表示する"
	/* フッター表示 */
	$footter_setting 	= get_option('bcj_set_footter_setting'); // デフォルトは"表示する"
	/* サイトアイコンURL */
	$siteicon_url 		= get_option('bcj_set_siteicon_url'); // デフォルトはテスト画像指定
	/* NoImage URL */
	$noimage_url 		= get_option('bcj_set_noimage_url'); // デフォルトはテスト画像指定
	/* サイトタイトル文字列 */
	$site_title 		= get_option('bcj_set_site_title'); // サイトタイトル文字列
	if($site_title ==""){
		$site_title = get_bloginfo('name');
	}
	/* 記事の日付 */
	$article_date_setting = get_option('bcj_set_article_date_setting'); // 記事の日付
	
	//マッチしたURL一つ一つをループしてカードを作成
	foreach ($m[0] as $match) {
		$url 	= strip_tags($match);//URL
		$id 	= url_to_postid( $url );//IDを取得（URLから投稿ID変換）
		if ( !$id ) continue;//IDを取得できない場合はループを飛ばす
		
		$post 			= get_post($id);//IDから投稿情報の取得
		$title 			= $post->post_title;//タイトルの取得
		$date 			= mysql2date('Y-m-d', $post->post_date);//投稿日の取得
		
		$excerpt 	= blog_card_jin_20160901_get_the_custom_excerpt($post->post_content, $excerpt_length);//抜粋の取得
		//$sitetitle 	= get_bloginfo('name');
		$thumbnail 	= get_the_post_thumbnail($id, 'thumbnail', array('class' => 'bcj-thumb-image'));
		
		if($thumbnail_setting =="表示する"){
			if ($thumbnail) {//サムネイルがある場合
				$thumbnail_tag 	= '
					<div class="bcj-thumbnail">
					<a href="'.$url.'" class="bcj-thumbnail-link">'.$thumbnail.'</a></div>';
				$tag_blog_card 	= 'class="bcj thumbnail-yes"';
			}else{//サムネイルがない場合
				$thumbnail = '<img class="bcj-thumb-image no-image" src="'.$noimage_url.'" />';
				if($noimage_setting =="表示する"){
					$thumbnail_tag 	= '
					<div class="bcj-thumbnail">
					<a href="'.$url.'" class="bcj-thumbnail-link">'.$thumbnail.'</a></div>';
					$tag_blog_card 	= 'class="bcj thumbnail-yes"';
				}
				else{
					$thumbnail_tag ="";
					$tag_blog_card 	= 'class="bcj thumbnail-no"';
				}
			}
		}
		else{
			$thumbnail_tag = '';
			$tag_blog_card 	= 'class="bcj thumbnail-no"';
		}

		if($article_date_setting =="表示する"){
			$footter_date	= '<span class="bcj-date">'.$date.'</span>';
		}else{
			$footter_date	="";
		}
		if($footter_setting =="表示する"){
			$footter_setting_tag 	= '
			<div class="bcj-footer clear">
				<span class="bcj-siteicon"><img src="'.$siteicon_url.'"><span>'.$site_title.'</span></span>'.$footter_date.'</div>';
		}
		else{
			$footter_setting_tag = '';
		}
		
		//取得した情報からブログカードのHTMLタグを作成
		$tag = '
		<div '.$tag_blog_card.' style="max-width:'.$card_width.'px">'.$header_title.$thumbnail_tag.'
				<div class="bcj-title"><a href="'.$url.'" class="bcj-title-link">'.$title.'</a></div>
				<div class="bcj-excerpt">'.$excerpt.'</div>
			</a>
		'.$footter_setting_tag.'
		</div>';

		//本文中のURLをブログカードタグで置換
		$the_content = preg_replace('{'.preg_quote($match).'}', $tag , $the_content, 1);
	}
	}
	return $the_content;//置換後のコンテンツを返す
}
add_filter('the_content','blog_card_jin_20160901_url_to_blog_card');//本文表示をフック

//CSS追加関数
function blog_card_jin_20160901_css_init(){
	wp_enqueue_style('card-style', plugins_url('css/blogcard-jin-style201609011330.css', __FILE__));
}
add_action('wp_enqueue_scripts', 'blog_card_jin_20160901_css_init');

/* -----------------------------------
設定画面
----------------------------------- */
//初期化 プラグインが有効化された時
function blog_card_jin_20160901_init(){
    if(!get_option('bcj_set_card_width')){
        add_option('bcj_set_card_width', 550);
    }
    if(!get_option('bcj_set_header_title')){
        add_option('bcj_set_header_title', "関連記事 >");
    }
    if(!get_option('bcj_set_length_value')){
        add_option('bcj_set_length_value', 110);
    }
    if(!get_option('bcj_set_siteicon_url')){
        add_option('bcj_set_siteicon_url', plugins_url('images/catblack.png', __FILE__));
    }
    if(!get_option('bcj_set_noimage_url')){
        add_option('bcj_set_noimage_url', plugins_url('images/no-image.png', __FILE__));
    }
    if(!get_option('bcj_set_thubnaildisp_value')){
        add_option('bcj_set_thubnaildisp_value', "表示する");
    }
    if(!get_option('bcj_set_noimagedisp_value')){
        add_option('bcj_set_noimagedisp_value', "表示する");
    }
    if(!get_option('bcj_set_footter_setting')){
        add_option('bcj_set_footter_setting', "表示する");
    }
    if(!get_option('bcj_set_site_title2')){
        add_option('bcj_set_site_title2', get_bloginfo('name'));
    }
    if(!get_option('bcj_set_article_date_setting')){
        add_option('bcj_set_article_date_setting', "表示する");
    }
/*
	$card_width			= 550;
	$header_title		= "関連記事 >";
	$excerpt_length 	= 110;
	$siteicon_url		= plugins_url('images/catblack.png', __FILE__);
	$noimage_url		= plugins_url('images/no-image.png', __FILE__);
	$thumbnail_setting	= "表示する";
	$noimage_setting	= "表示する";
	$footter_setting	= "表示する";
	$article_date_setting	= "表示する";
*/
}
register_activation_hook( __FILE__, 'blog_card_jin_20160901_init' );


add_action('admin_menu', 'blog_card_jin_20160901_admin_menu');
 
function blog_card_jin_20160901_admin_menu() {
//	add_options_page( $page_title, $menu_title, $capability, $menu_slug, $function);
	add_options_page(
		'blog-card Jin',
		'Blog Card Jin',
		8,
		'blog_card_jin_20160901_admin_menu',
		'blog_card_jin_20160901_edit_setting'
	);
}

function blog_card_jin_20160901_edit_setting() {
	wp_enqueue_style( "card_style_edit_css", plugins_url( 'css/blogcard-jin-style-edit.css', __FILE__ ) );
	
	/* -----------------------------------
		カード全体の横の長さ
	-----------------------------------*/
	if (isset($_POST['card_width'])) {
		update_option('bcj_set_card_width', $_POST['card_width']);
	}
	$card_width = get_option('bcj_set_card_width');
	
	if($card_width<=0){
		$card_width = 550;
		update_option('bcj_set_card_width', "550");
	}
	/* -----------------------------------
		ヘッダータイトル
	-----------------------------------*/
	if (isset($_POST['header_title'])) {
		update_option('bcj_set_header_title', $_POST['header_title']);
	}
	$header_title = get_option('bcj_set_header_title');
	
	/* -----------------------------------
		抜粋の長さ
	-----------------------------------*/
	if (isset($_POST['length_setting'])) {
		update_option('bcj_set_length_value', $_POST['length_setting']);
	}
	$length_setting = get_option('bcj_set_length_value');

	if($length_setting<=0){
		$length_setting = 110;
		update_option('bcj_set_length_value', "110");
	}
	
	/* -----------------------------------
		サムネイル表示ありなし
	-----------------------------------*/
	if (isset($_POST['thumbnail_setting'])) {
		update_option('bcj_set_thubnaildisp_value', $_POST['thumbnail_setting']);
	}
	$thumbnail_setting 	= get_option('bcj_set_thubnaildisp_value');

	if($thumbnail_setting=="表示する"){
		$thumbnail_setting_check1 =' checked="checked"';
		$thumbnail_setting_check2 ='';
	}
	else{
		$thumbnail_setting_check1 ='';
		$thumbnail_setting_check2 =' checked="checked"';
	}
	
	/* -----------------------------------
		サムネイルがない場合のイメージ表示ありなし
	-----------------------------------*/
	if (isset($_POST['noimage_setting'])) {
		update_option('bcj_set_noimagedisp_value', $_POST['noimage_setting']);
	}
	$noimage_setting = get_option('bcj_set_noimagedisp_value');
//	if($noimage_setting ? $noimage_setting:"表示する");
	
	if($noimage_setting=="表示する"){
		$noimage_setting_check1 =' checked="checked"';
		$noimage_setting_check2 ='';
	}
	else{
		$noimage_setting_check1 ='';
		$noimage_setting_check2 =' checked="checked"';
	}

	/* -----------------------------------
		フッターの表示
	-----------------------------------*/
	if (isset($_POST['footter_setting'])) {
		update_option('bcj_set_footter_setting', $_POST['footter_setting']);
	}
	$footter_setting = get_option('bcj_set_footter_setting');
	
	if($footter_setting=="表示する"){
		$footer_setting_check1 =' checked="checked"';
		$footer_setting_check2 ='';
	}
	else{
		$footer_setting_check1 ='';
		$footer_setting_check2 =' checked="checked"';
	}

	
	/* -----------------------------------
		NoImage URL
	-----------------------------------*/
	if (isset($_POST['noimage_url'])) {
		update_option('bcj_set_noimage_url', $_POST['noimage_url']);
	}
	$noimage_url = get_option('bcj_set_noimage_url');
	
	if($noimage_url ==""){
		$noimage_url = plugins_url('images/no-image.png', __FILE__);
		update_option('bcj_set_noimage_url', $noimage_url);
	}

	/* -----------------------------------
		サイトアイコンURL
	-----------------------------------*/
	if (isset($_POST['siteicon_url'])) {
		update_option('bcj_set_siteicon_url', $_POST['siteicon_url']);
	}
	$siteicon_url = get_option('bcj_set_siteicon_url');
	
	if($siteicon_url==""){
		$siteicon_url = plugins_url('images/catblack.png', __FILE__);
		update_option('bcj_set_siteicon_url', $siteicon_url);
	}
	
	/* -----------------------------------
		Site Title
	-----------------------------------*/
	if (isset($_POST['site_title'])) {
		update_option('bcj_set_site_title', $_POST['site_title']);
	}
	$site_title = get_option('bcj_set_site_title');
	
	if($site_title==""){
		$site_title = get_bloginfo("name");
		update_option('bcj_set_site_title', $site_title);
	}


	/* -----------------------------------
		記事日付の表示
	-----------------------------------*/
	if (isset($_POST['article_date_setting'])) {
		update_option('bcj_set_article_date_setting', $_POST['article_date_setting']);
	}
	$article_date_setting = get_option('bcj_set_article_date_setting');
	
	if($article_date_setting=="表示する"){
		$article_date_setting_check1 =' checked="checked"';
		$article_date_setting_check2 ='';
	}
	else{
		$article_date_setting_check1 ='';
		$article_date_setting_check2 =' checked="checked"';
	}
echo <<<EOD
<div id="blog-card-jin-settings">
<h2>Blog Card Jin Settings</h2>
<form action="" method="post">
<div class="settings">
<table>
	<tr>
		<td><p class="title">カードの最大横幅</p><span class="comment">（空白：初期値に戻る）</span></td>
		<td><input type="text" name="card_width" size="4" value="{$card_width}" />px</p></td>
	</tr>
	<tr>
		<td><p class="title">ヘッダーの文字列</p><span class="comment">（空白：行は非表示）</span>
		<td><input class="header_title" type="text" name="header_title" size="10" value="{$header_title}" /></p>
	</tr>
	<tr>
		<td><p class="title">サムネイルの表示</p>
		<td>
			<input type="radio" name="thumbnail_setting" value="表示する" {$thumbnail_setting_check1} />表示する
			<input type="radio" name="thumbnail_setting" value="表示しない" {$thumbnail_setting_check2} />表示しない
		</td>
	</tr>
	<tr>
		<td><p class="title">サムネイルがない場合のNoImage表示</p>
		<td>
			<input type="radio" name="noimage_setting" value="表示する" {$noimage_setting_check1} />表示する
			<input type="radio" name="noimage_setting" value="表示しない" {$noimage_setting_check2} />表示しない
		</td>
	</tr>
	<tr>
		<td><p class="title">NoImageのURL</p><span class="comment">（空白：初期値に戻る）</span></td>
		<td><input class="url" type="text" name="noimage_url"  size="80" value="{$noimage_url}" /></p></td>
	</tr>
	<tr>
		<td><p class="title">抜粋の文字数</p><span class="comment">（空白：初期値に戻る）</span></td>
		<td><input type="text" name="length_setting" size="4" value="{$length_setting}" /></p></td>
	</tr>
	<tr>
		<td><p class="title">フッターの表示</p>
		<td>
			<input type="radio" name="footter_setting" value="表示する" {$footer_setting_check1} />表示する
			<input type="radio" name="footter_setting" value="表示しない" {$footer_setting_check2} />表示しない
		</td>
	</tr>
	<tr>
		<td><p class="title">サイトアイコンのURL</p><span class="comment">（空白：初期値に戻る）</span></td>
		<td><input class="url" type="text" name="siteicon_url"  size="80" value="{$siteicon_url}" /></p></td>
	</tr>
	<tr>
		<td><p class="title">サイトタイトル</p><span class="comment">（空白：初期値に戻る）</span></td>
		<td><input class="site_title" type="text" name="site_title"  size="80" value="{$site_title}" /></p></td>
	</tr>
	<tr>
		<td><p class="title">記事のの日付表示</p>
		<td>
			<input type="radio" name="article_date_setting" value="表示する" {$article_date_setting_check1} />表示する
			<input type="radio" name="article_date_setting" value="表示しない" {$article_date_setting_check2} />表示しない
		</td>
	</tr>
</table>
<input type="submit" value="登録" />
</form>
</div>
EOD;
}
?>